#!/usr/local/bin/perl
# e.bot - V1.7 - (c) Tim Henderson web-bureau.com 2003
# Process Orders Received Via Email Automatically
#--------------------------------------------------------------------------------------------
# This fine script is offered as CONTRIBUTION-WARE:  
#    - For personal use, send me an email and let me know how you get on!
#    - For commercial use, make a donation - the amount is up to you!
#--------------------------------------------------------------------------------------------
# To contribute to The Webmaster's Bureau, or pay for commercial usage of this script see:
# http://web-bureau.com/contribute.php
#============================================================================================

# Use the Database Interface Library
#------------------------------------
use DBI;
my $err = 0;     # Current error number

# Print start-up msg
#---------------------
my $t=gmtime();
print "\n>> e.bot... ($t) ";

# Open count file - stores the current order number
#---------------------------------------------------
my $cnt;
open (CNT, '+</home/yourname/cgi-bin/count');
read (CNT, $cnt, 10);
seek (CNT, 0, 0);
print CNT ++($cnt);
close (CNT);
print "ORDER: $cnt\n";

# Open log file and record everything into it
#----------------------------------------------
open (OUT, ">/home/yourname/orders/order.$cnt");
while (<STDIN>) {
  next if /^\s*$/;
  print OUT $_;
  print;
  chomp;
  if (/Order Number: /)     { $order_id = $'; }
  if (/Product ID: /)       { $product_id = $'; }
  if (/Name: /)             { $name = $'; }
  if (/Address1: /)         { $addr1 = $'; }
  if (/Address2: /)         { $addr2 = $'; }
  if (/City: /)             { $city = $'; }
  if (/State: /)            { $state = $'; }
  if (/Zip: /)              { $zip = $'; }
  if (/Country: /)          { $country = $'; }
  if (/Phone: /)            { $phone = $'; }
  if (/^E-Mail: /)          { $email_addr = $'; }
  if (/Subscribe E-Mail: /) { $subscribe = $'; }
  if (/Grand Total: /)      { $total = $'; }
  }

# Strip out whitespace
#----------------------
for ($order_id) { s/^\s+//; s/\s+$//; }
for ($product_id) { s/^\s+//; s/\s+$//; }
for ($email_addr) { s/^\s+//; s/\s+$//; }
for ($total) { s/^\s+//; s/\s+$//; }
for ($name) { s/^\s+//; s/\s+$//; }
for ($addr1) { s/^\s+//; s/\s+$//; }
for ($addr2) { s/^\s+//; s/\s+$//; }
for ($city) { s/^\s+//; s/\s+$//; }
for ($state) { s/^\s+//; s/\s+$//; }
for ($zip) { s/^\s+//; s/\s+$//; }
for ($country) { s/^\s+//; s/\s+$//; }
for ($phone) { s/^\s+//; s/\s+$//; }
for ($subscribe) { s/^\s+//; s/\s+$//; }

# Check the essentials are there...
#-----------------------------------
if (!$order_id)   { $err_txt[$err++]="No order id\n"; }
if (!$product_id) { $err_txt[$err++]="No product id\n"; }
if (!$email_addr) { $err_txt[$err++]="No email address\n"; }
if (!$total)      { $err_txt[$err++]="No total price\n"; }

# Connect the DB
#-----------------
$dbh = DBI->connect("DBI:mysql:yourname:localhost:3306", 'yourname', 'yourpassword');

# Insert the data
#-----------------
$statement = "insert into orders (counter, order_id, pid, name, addr1, addr2, city, state, zip, country, phone, email, subscribe, price)";
$statement .= "values ($cnt, \"$order_id\", \"$product_id\", \"$name\", \"$addr1\", \"$addr2\", \"$city\", \"$state\", \"$zip\", \"$country\", \"$phone\", \"$email_addr\", \"$subscribe\", \"$total\")";
$sth = $dbh->prepare($statement) or print "Can't prepare the SQL\n";
$rv  = $sth->execute or print "Can't execute the query: $sth->errstr";
print $rv, " rows inserted\n";

# Get the product password from the DB
#---------------------------------------
$statement = "select password from products where pid=\"$product_id\"";
$sth = $dbh->prepare($statement) or print "Can't prepare the SQL\n";
$rv  = $sth->execute or print "Can't execute the query: $sth->errstr";
if ($rv == '0E0') { $err_txt[$err++]="Product not found\n"; }
@row = $sth->fetchrow_array;
$sth->finish;

# If any errors...
#------------------
if ($err) {
  if ($email_addr) {
    &send_mail ($email_addr, "Error in Order!", "Dear Customer,\n  The following errors occurred while processing your order:\n@err_txt\n\nA human will process your order within the next few days. We apologise for the delay.\n\nThanks\n\n");
    }
  print "$err errors!: \n@err_txt";
  }

# Success! Send password etc. to customer.
#-------------------------------------------
else {
  &send_mail($email_addr, "Your Password...", "Dear Customer,\n Thankyou for your order. \n\nYour password is: $row[0].\n If you have any problems, please contact us: \n\nsales\@yourdomain.com");
  }

$dbh->disconnect;

#-----------------------
# Subroutine: send_mail
#------------------------
sub send_mail {
open(MAIL, "|/usr/lib/sendmail -t") or die ("FATAL: Failed open mail!");
print MAIL <<"EOM";
To: $_[0]
Subject: $_[1]
From: yourdomain.com <e\-bot\@yourdomain.com>
Sender: e\-bot\@yourdomain.com
Reply-To: sales\@yourdomain.com\n
$_[2]
\n.\n
EOM
close (MAIL);
}